# Couenne::exprSub Class Reference

class for subtraction, More...

`#include <CouenneExprSub.hpp>`

Inheritance diagram for Couenne::exprSub:

List of all members.

## Public Member Functions
| exprSub (expression **al, int n=2)
| Constructor.
| exprSub (expression *arg0, expression *arg1)
| Constructor with two explicit elements.
expression * | clone (Domain *d=NULL) const
| Cloning method.
std::string | printOp () const
| print operator
CouNumber | operator() ()
| Function for the evaluation of the difference.
expression * | differentiate (int index)
| Differentiation.
expression * | simplify ()
| Simplification.
virtual int | Linearity ()
| Get a measure of "how linear" the expression is (see CouenneTypes.h).
void | getBounds (expression *&, expression *&)
| Get lower and upper bound of an expression (if any).
void | getBounds (CouNumber &lb, CouNumber &ub)
| Get value of lower and upper bound of an expression (if any).
virtual exprAux * | standardize (CouenneProblem *p, bool addAux=true)
| Reduce expression in standard form, creating additional aux variables (and constraints).
virtual void | generateCuts (expression *, OsiCuts &, const CouenneCutGenerator *, t_chg_bounds *=NULL, int=-1, CouNumber=-COUENNE_INFINITY, CouNumber=COUENNE_INFINITY)
| Special version for linear constraints.
virtual enum expr_type | code ()
| Code for comparisons.
bool | impliedBound (int, CouNumber *, CouNumber *, t_chg_bounds *, enum auxSign=expression::AUX_EQ)
| Implied bound processing.

## Detailed Description

class for subtraction,

Definition at line 22 of file CouenneExprSub.hpp.

## Constructor & Destructor Documentation

Couenne::exprSub::exprSub | ( | expression ** | al,
|  | int | n = `2` |
| ) |  |  | `[inline]`

Constructor.

Definition at line 27 of file CouenneExprSub.hpp.

Referenced by clone().

Couenne::exprSub::exprSub | ( | expression * | arg0,
|  | expression * | arg1 |
| ) |  |  | `[inline]`

Constructor with two explicit elements.

Definition at line 31 of file CouenneExprSub.hpp.

## Member Function Documentation

expression* Couenne::exprSub::clone | ( | Domain * | d = `NULL` | ) | const`[inline, virtual]`

Cloning method.

Reimplemented from Couenne::expression.

Definition at line 35 of file CouenneExprSub.hpp.

References Couenne::exprOp::clonearglist(), exprSub(), and Couenne::exprOp::nargs_.

std::string Couenne::exprSub::printOp | ( |  | ) | const`[inline, virtual]`

print operator

Reimplemented from Couenne::exprOp.

Definition at line 39 of file CouenneExprSub.hpp.

CouNumber Couenne::exprSub::operator() | ( |  | ) | `[inline, virtual]`

Function for the evaluation of the difference.

Compute difference.

Implements Couenne::expression.

Definition at line 88 of file CouenneExprSub.hpp.

References Couenne::exprOp::arglist_.

expression* Couenne::exprSub::differentiate | ( | int | index | ) | `[virtual]`

Differentiation.

Reimplemented from Couenne::expression.

expression* Couenne::exprSub::simplify | ( |  | ) | `[virtual]`

Simplification.

Reimplemented from Couenne::exprOp.

virtual int Couenne::exprSub::Linearity | ( |  | ) | `[inline, virtual]`

Get a measure of "how linear" the expression is (see CouenneTypes.h).

Reimplemented from Couenne::exprOp.

Definition at line 52 of file CouenneExprSub.hpp.

References Couenne::exprOp::arglist_.

void Couenne::exprSub::getBounds | ( | expression *& | ,
|  | expression *& |  |
| ) |  |  |

Get lower and upper bound of an expression (if any).

void Couenne::exprSub::getBounds | ( | CouNumber & | lb,
|  | CouNumber & | ub |
| ) |  |  | `[virtual]`

Get value of lower and upper bound of an expression (if any).

Reimplemented from Couenne::expression.

virtual exprAux* Couenne::exprSub::standardize | ( | CouenneProblem * | p,
|  | bool | addAux = `true` |
| ) |  |  | `[virtual]`

Reduce expression in standard form, creating additional aux variables (and constraints).

Reimplemented from Couenne::exprOp.

virtual void Couenne::exprSub::generateCuts | ( | expression * | ,
|  | OsiCuts & | ,
|  | const CouenneCutGenerator * | ,
|  | t_chg_bounds * | = `NULL`,
|  | int | = `-1`,
|  | CouNumber | = `-COUENNE_INFINITY`,
|  | CouNumber | = `COUENNE_INFINITY` |
| ) |  |  | `[virtual]`

Special version for linear constraints.

virtual enum expr_type Couenne::exprSub::code | ( |  | ) | `[inline, virtual]`

Code for comparisons.

Reimplemented from Couenne::exprOp.

Definition at line 79 of file CouenneExprSub.hpp.

References Couenne::COU_EXPRSUB.

bool Couenne::exprSub::impliedBound | ( | int | ,
|  | CouNumber * | ,
|  | CouNumber * | ,
|  | t_chg_bounds * | ,
|  | enum | auxSign = `expression::AUX_EQ` |
| ) |  |  | `[virtual]`

Implied bound processing.

Reimplemented from Couenne::expression.

The documentation for this class was generated from the following file:

- CouenneExprSub.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines